//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymRepBlks.h"
#include "Mixmaster.h"
#include "global.h"
//---------------------------------------------------------------------------
// TRListTxt
//---------------------------------------------------------------------------
__fastcall TRListTxt::TRListTxt()
{
}
//---------------------------------------------------------------------------
__fastcall TRListTxt::TRListTxt(TStrings *RListTxt)
{
   AddStrings(RListTxt);
}
//---------------------------------------------------------------------------
__fastcall TRListTxt::TRListTxt(AnsiString RListTxtFile)
{
   if (FileExists(RListTxtFile)) LoadFromFile(RListTxtFile);
}
//---------------------------------------------------------------------------
__fastcall TRListTxt::~TRListTxt()
{
}
//---------------------------------------------------------------------------
bool __fastcall TRListTxt::ValidRemailer(AnsiString &nameaddress)
{
   AnsiString line,name=NameFromNameAddress(nameaddress);
   if (name.IsEmpty()) return false;
   return InStats(name);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRListTxt::NameFromNameAddress(AnsiString &nameaddress)
{
   if (nameaddress.Pos("@")==0) return nameaddress;
   return GetNameFromAddress(nameaddress);
}
//---------------------------------------------------------------------------
bool __fastcall TRListTxt::InStats(AnsiString &nameaddress)
{
   AnsiString line,name=NameFromNameAddress(nameaddress);
   if (name.IsEmpty()) return false;

   int i=0; while(++i<Count)
   {
      line = Strings[i];
      if (line.Pos("%")==0) continue;
      if (line.Pos(name+" ")==1)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRListTxt::GetNameFromAddress(AnsiString &address)
{
   AnsiString line;
   int i=-1; while(++i<Count)
   {
      line = Strings[i]; if (line.Pos("$rem")!=1) continue;
      if (GetAddress(line)==address)
         return GetToken(1,line,"\"");
   }
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRListTxt::GetAddressFromName(AnsiString &name)
{
   AnsiString line;
   int i=-1; while(++i<Count)
   {
      line = Strings[i]; if (line.Pos("$rem")!=1) continue;
      if (GetToken(1,line,"\"")==name)
         return GetAddress(line);
   }
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRListTxt::GetAddress(AnsiString &fromcapsline)
{
   return GetToken(0,GetToken(1,fromcapsline,"<"),">");
}
//---------------------------------------------------------------------------
bool __fastcall TRListTxt::HasCap(AnsiString nameaddress, AnsiString &capinquestion)
{
   AnsiString capline=GetCapsFromNameAddress(nameaddress);
   return capline.Pos(" "+capinquestion+" ")>0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRListTxt::GetCapsFromNameAddress(AnsiString &nameaddress)
{
   AnsiString line,name=NameFromNameAddress(nameaddress);
   if (!InStats(name)) return "";

   int i=-1; while(++i<Count)
   {
      line = Strings[i]; if (line.Pos("$rem")!=1) continue;
      if (GetToken(0,line," ")==name) return line;
   }
   return "";
}
//---------------------------------------------------------------------------
// TReplyBlockLeg
//---------------------------------------------------------------------------
__fastcall TReplyBlockLeg::TReplyBlockLeg()
   : TStringList()
{
   rlist = NULL;
}
//---------------------------------------------------------------------------
__fastcall TReplyBlockLeg::TReplyBlockLeg(TStrings *Leg)
   : TStringList()
{
   rlist = new TRListTxt(clisttxt);
   AddStrings(Leg);
}
//---------------------------------------------------------------------------
__fastcall TReplyBlockLeg::TReplyBlockLeg(int Pos, TStrings *ReplyBlock)
   : TStringList()
{
   rlist = new TRListTxt(clisttxt);
   GetLeg(Pos,ReplyBlock);
}
//---------------------------------------------------------------------------
__fastcall TReplyBlockLeg::~TReplyBlockLeg()
{
   delete rlist;
}
//---------------------------------------------------------------------------
bool __fastcall TReplyBlockLeg::LabelMatchesAnonTo()
{
   if (Count<2) return false;
   int i=-1; while(++i<Count-1)
   {

      if (Strings[i].Pos("-To: "+Label())>0)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TReplyBlockLeg::Label()
{
   return Count<2 ? s(""):Strings[Count-1];
}
//---------------------------------------------------------------------------
AnsiString __fastcall TReplyBlockLeg::RemailerName()
{
   return Count<2 ? s(""):rlist->NameFromNameAddress(Label());
}
//---------------------------------------------------------------------------
bool __fastcall TReplyBlockLeg::ValidRemailer()
{
   return rlist->InStats(RemailerName());
}
//---------------------------------------------------------------------------
bool __fastcall TReplyBlockLeg::Valid()
{
   if (LabelMatchesAnonTo() && RemailerName().IsEmpty() && ValidRemailer())
      return true;
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TReplyBlockLeg::GetLeg(int Pos, TStrings *FromReplyBlock)
{
   int i,pos=0; Clear();
   for (i=1; i<FromReplyBlock->Count; i++)
   {
      AnsiString line=FromReplyBlock->Strings[i];
      if (pos==Pos)
      {
         Add(line.Trim());
         if (line.Pos(":")==0) break;
         continue;
      }
      if (line.Pos(":")==0) pos++;
   }
   return Count>0;
}
//---------------------------------------------------------------------------
// TReplyBlock
//---------------------------------------------------------------------------
__fastcall TReplyBlock::TReplyBlock()
   : TStringList()
{
}
//---------------------------------------------------------------------------
__fastcall TReplyBlock::TReplyBlock(TStrings *ReplyBlock)
   : TStringList()
{
   AddStrings(ReplyBlock);
}
//---------------------------------------------------------------------------
__fastcall TReplyBlock::TReplyBlock(int Pos, TStrings *FromNymProfile)
   : TStringList()
{
   GetBlock(Pos,FromNymProfile);
}
//---------------------------------------------------------------------------
__fastcall TReplyBlock::~TReplyBlock()
{
}
//---------------------------------------------------------------------------
bool __fastcall TReplyBlock::GetBlock(int Pos, TStrings *FromNymProfile)
{
   int i,pos=-1; Clear();
   for (i=1; i<FromNymProfile->Count; i++)
   {
      AnsiString line=FromNymProfile->Strings[i];
      if (line.Pos("-----BEGIN PGP")==1) break;
      if (line.TrimLeft().Pos("Reply-Block:")==1) ++pos;
      if (pos==Pos && !line.Trim().IsEmpty())
      {
         Add(line);
         continue;
      }
      if (pos==Pos && (line.IsEmpty() || line.Pos("Reply-Block:")==1))
         break;
   }
   return Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall TReplyBlock::GetLeg(int Pos, TStrings *ToStrings)
{
   int i,pos=0;
   ToStrings->Clear();
   for (i=1; i<Count; i++)
   {
      AnsiString line=Strings[i];
      if (pos==Pos)
      {
         ToStrings->Add(line.Trim());
         if (line.Pos(":")==0) break;
         continue;
      }
      if (line.Pos(":")==0) pos++;
   }
   return Count>0;
}
//---------------------------------------------------------------------------
int  __fastcall TReplyBlock::LegCount()
{
   int legs=0; for (int i=1; i<Count; i++)
      if (Strings[i].Pos(":")==0) legs++;
   return legs;
}
//---------------------------------------------------------------------------
